<?php
/*
Plugin Name: jKeyMagic
Plugin URI: http://ttkz.me/jkeymagic
Description: Add jKeyMagic to comment box. More info about KeyMagic (http://code.google.com/p/keymagic)
Author: Thant Thet Khin Zaw
Version: 1.0
Author URI: http://ttkz.me/
*/

$jkeymagic = new jkeymagic();
$jkeymagic->hook();

class jkeymagic {
    
    static $option_name = 'jkeymagic';
    
    public function hook() {
        add_action('init', array('jkeymagic', 'init'));
        add_action('wp_head', array('jkeymagic', 'wp_head'));
        add_action('wp_footer', array('jkeymagic', 'wp_footer'));
        
        add_action('admin_menu', array('jkeymagic', 'admin_menu'));

		if ( ! get_option(jkeymagic::$option_name) ) {
		    $options['show_powered'] = 'on';
		    add_option(jkeymagic::$option_name, $options );
		}
    }
    
    public static function admin_menu() {
		add_options_page('jKeyMagic', 'jKeyMagic', 8, 'jkeymagic', array('jkeymagic', 'options'));
	}
	
	function data_save()
	{
		if(isset($_POST['submitter']))
		{
			$options['show_powered'] = $_POST['show_powered'];
			
			if ( get_option(jkeymagic::$option_name) )
				update_option(jkeymagic::$option_name, $options);
			else
				add_option(jkeymagic::$option_name, $options );
		}
	}
	
	public static function options() {
	    jkeymagic::data_save();
		$options = get_option(jkeymagic::$option_name);
		$checked = $options['show_powered'] ? 'checked' : '';
	?>
	    <div class="wrap">
	        <div class="jkeymagic">
			<form method="post" name="jkeymagic_form">
			    <p><input <?php echo $checked  ?> type="checkbox" name="show_powered" id="show_powered"/>
			    <label for="show_powered" >Show 'Powered by jKeyMagic'</label></p>
			    <p><input type="submit" name="submitter" value="<?php esc_attr_e('Save Changes') ?>" class="button-primary" /></p>
		    </form>
		    </div>
	    </div>
	<?php
	}
    
    public static function init() {
       // register your script location, dependencies and version
       wp_register_script('jkeymagic', plugins_url( 'js/jkeymagic.js' , __FILE__ ));
       // enqueue the script
       wp_enqueue_script('jkeymagic');
	}
	
	public static function wp_head() {
	?>
	    <!-- jKeyMagic CSS START -->
	    <link rel="stylesheet" href="<?php echo plugins_url( 'css/jkeymagic.css' , __FILE__ ); ?>" type="text/css" media="screen" charset="utf-8">
	    <!-- jKeyMagic CSS END -->
	<?php
	}
	
	public static function print_path($path) {
	    echo '"' . plugins_url($path, __FILE__) . '"';
	}
	
	public static function wp_footer() {
	    $options = get_option(jkeymagic::$option_name);
	?>
	    <!-- jKeyMagic START -->
	    <script type="text/javascript">
	    
	    if (JKME) {

        keyboards = [
        	[<?php jkeymagic::print_path('js/kb/Myanmar3.js'); ?>, 'Myanmar3'],
        	[<?php jkeymagic::print_path('js/kb/Zawgyi L - Unicode.js'); ?>, 'ZawgyiL - Unicode'],
        ];

        for (var i in keyboards) {
        	keyboard = keyboards[i];
        	JKME.keyboard.addKeyboard(keyboard[0], keyboard[1]);
        }
        
        JKME.config.logoUrl = <?php jkeymagic::print_path('images/keymagic.png'); ?>;

        elements = document.getElementsByTagName('textarea');
        for (i = 0; i < elements.length; i++) {
          if (elements[i].readOnly == false)
            JKME.attach(elements[i]);
        }
        
        }

        </script>
        <?php if ($options['show_powered']) : ?>
        <div style="font-size:10px;absolute:fixed;bottom:5px;text-align:right;">
            Powered by <a href='http://ttkz.me/jkeymagic/index.html'><font color="#ed145b">jKeyMagic</font></a>
        </div>
        <?php endif; ?>
        <!-- jKeyMagic END -->
	<?php
	}
}
?>